<template>
  <apexchart
    ref="ChartBubblesJobs"
    height="350px"
    :options="chartOptions"
    :series="series" />
</template>

<script>
import VueApexCharts from 'vue3-apexcharts'

const conf = config()

export default {
  components: {
    apexchart: VueApexCharts
  },
  data () {
    return {
      series: [],
      chartOptions: {
            noData: {
              text: "No jobs found so far..."
            },
            colors: ['#f2c037', '#21ba45', '#c10015', '#26a69a'],
            chart: {
                type: 'bubble',
                toolbar: {
                  show: true,
                },
            },
            dataLabels: {
                enabled: false
            },
            legend: { position: 'top', horizontalAlign: 'center' },
            plotOptions: {
              bubble: {
                minBubbleRadius: 3,
                maxBubbleRaius: 2000,
              }
            },
            title: {
                text: "Jobs executed",
                style: {
                   fontSize: '16px'
                }
            },
            subtitle: {
                text: "Bubble size represents the number of tests inside a job. But bubbles too small might be an empty job."
            },
            fill: {
                opacity: 0.6
            },
            yaxis: {
               decimalsInFloat: 2,
               forceNiceScale: true,
            },
            xaxis: {
               type: "datetime",
                labels: {
                   datetimeFormatter: {
                     year: 'yyyy',
                     month: 'MMM \'yy',
                     day: 'dd MMM',
                     hour: 'HH:mm'
                   }
                }
            }
      } 
    }
  },
  mounted() {
    let project_id = this.$route.params.id
    fetch(conf.I4C_API_SERVER + "/projects/" + project_id + "/jobs")
      .then(response => response.json())
      .then(data => (this.update(data)));
  },

  methods: {
    async update (jobs) {
      if (jobs === undefined) {
         return
      }
         
      let results = {'failed': [],
                     'success': [],
                     'error': [],
                     'skipped': []}

      jobs.forEach(function(job) {
        let created_at = new Date(job.created_at).getTime()
        let finished_at = new Date(job.finished_at).getTime()
        let diff = (finished_at - created_at) / 60000 // mili to minutes
        let item = [job.created_at, Math.max(diff, 0), job.tests_length || 5.23]
        results[job.status].push(item)
      })
      let series = []
      const keys = ['failed', 'success', 'error', 'skipped']
      keys.forEach(function (key) {
          series.push({'name': key, 'data': results[key]})
      })
      this.series = series
    }
  }
}
</script>

<style>

.apexcharts-marker {
  stroke-width: 1px;
}

</style>
